<?php

//ob_implicit_flush(true);
//ob_end_flush();
#ini_set('output_buffering', 0);
#ini_set('zlib.output_compression', 0);
#ini_set('implicit_flush', 1);

date_default_timezone_set('America/Denver');

set_error_handler("warning_handler", E_WARNING);
function warning_handler($errno, $errstr){
	echo '('.$errno . ' : ' . $errstr.') ';
}

$isRunningNonCommandline = true;

if(!function_exists("notify")) {
	function notify($m) {
	#file_put_contents("_executed_".time().".dat", $m);
	  //return; //DISABLE
	file_put_contents("current_page.dat", $m . ' <small>(' . date('m/d/Y G:i a') . ')</small><br>');
	  /*global $isRunningNonCommandline;
	  if($isRunningNonCommandline){
	    echo $m . "<br><br>\n";
	    echo "<script>
	          $('body').animate({
	              'scrollTop': $(document).height()
	          }); 
	          </script>\n";
	  }else{
	    file_put_contents("php://stderr", $m);    
	  }
	  flush();*/
	}
}

$cf = [];
$hasConfig = false;
$run_now = false;

if( isset($_POST['username']) ){
	$username = $cf['username'] = $_POST['username'];
	
	$remote_key = $cf['remote_key'] = $_POST['remote_key'];
	
	$file = $cf['file'] = 'ff_stream_' . $username . '.json';
	
	$media_dir = $cf['media_dir'] = "./ff_media";
	
	if( isset($_POST['remote_key']) ){
		$remote_key = $cf['remote_key'] = $_POST['remote_key'];
	}
	
	if( isset($_POST['download_images']) ){
		if($_POST['download_images'] == 'Y'){
			$all_pages = $cf['download_images'] = TRUE;
		}else{
			$all_pages = $cf['download_images'] = FALSE;
		}
	}else{
		$all_pages = $cf['download_images'] = TRUE; //default to True
	}
	
	if( isset($_POST['download_files']) ){
		if($_POST['download_files'] == 'Y'){
			$all_pages = $cf['download_files'] = TRUE;
		}else{
			$all_pages = $cf['download_files'] = FALSE;
		}
	}else{
		$all_pages = $cf['download_files'] = TRUE; //default to True
	}

	if( isset($_POST['convert_limit']) ){
		$convert_limit = $cf['convert_limit'] = $_POST['convert_limit'];
	}else{
		$cf['convert_limit'] = 200; //default 200 posts per page HTML conversion
	}

	if( isset($_POST['all_pages']) ){
		if($_POST['all_pages'] == 'Y'){
			$all_pages = $cf['all_pages'] = TRUE;
		}else{
			$all_pages = $cf['all_pages'] = FALSE;
		}
	}else{
		$all_pages = $cf['all_pages'] = TRUE; //default to True
	}
	
	if( isset($_POST['convert_all_pages']) ){
		if($_POST['convert_all_pages'] == 'Y'){
			$convert_all_pages = $cf['convert_all_pages'] = TRUE;
		}else{
			$convert_all_pages = $cf['convert_all_pages'] = FALSE;
		}
	}else{
		$convert_all_pages = $cf['convert_all_pages'] = TRUE; //default to True
	}
	
	if( isset($_POST['mode']) ){
		$mode = $cf['mode'] = $_POST['mode'];
	}else{
		$mode = $cf['mode'] = 'backup_convert'; //default to backup + convert
	}
		
	if( isset($_POST['max_pages']) ){
		if($_POST['max_pages'] === '0'){
			$max_pages = $cf['max_pages'] = 1;
		}else{
			$max_pages = $cf['max_pages'] = (int)$_POST['max_pages'];
		}
	}else{
		$max_pages = 0; //0 indicates all
	}
	
	if( isset($_POST['convert_max_pages']) ){
		if($_POST['convert_max_pages'] === '0'){
			$convert_max_pages = $cf['convert_max_pages'] = 1; //don't allow zero (which is unlimited) since specifiying max logically means not all
		}else{
			$convert_max_pages = $cf['convert_max_pages'] = (int)$_POST['convert_max_pages'];
		}
	}else{
		$convert_max_pages = 0; //0 indicates all
	}
	
	if($all_pages){
		$max_pages = $cf['max_pages'] = 0; //0 is all pages
	}
	
	if($convert_all_pages){
		$convert_max_pages = $cf['convert_max_pages'] = 0; // 0 is all pages
	}
	
	file_put_contents("config.json", json_encode($cf));
	
	$hasConfig = true;
	extract($cf);
	
	#var_dump($cf);
	#exit;
	$run_now = true;
}else{

	if(file_exists("config.json")){
		$hasConfig = true;
		$cf = json_decode(file_get_contents("config.json"), true);
		extract($cf);
		
		if($all_pages){
			$max_pages = $cf['max_pages'] = 0; //0 is all pages
		}

		if($convert_all_pages){
			$convert_max_pages = $cf['convert_max_pages'] = 0; // 0 is all pages
		}
		
	}
}

?>
<!doctype html>
<html>
<head>
  <title>Friendfeed Export and Format (ffexp.php and FFExp2HTMLex.php)</title>
  <style>
   div, p { font-family: Helvetica, Arial, san-serif; }
   a { text-decoration: none; }
   a:hover {
	color: red;
    cursor:pointer;
   }
  </style>
  <script src="http://ajax.googleapis.com/ajax/libs/jquery/1/jquery.min.js"></script>
</head>
<body>

	<form id="mainform"  method="post" action="http://localhost:8000">

		<strong>Mode</strong>: <select name="mode" id="mode">
			<?php
				if($mode == 'backup_convert' || !$hasConfig){
					echo '<option value="backup_convert" selected="selected">Backup + Convert</option><option value="backup">Backup Only</option><option value="convert">Convert Only</option>';
				}else if($mode == 'backup'){
					echo '<option value="backup" selected="selected">Backup Only</option><option value="convert">Convert Only</option><option value="backup_convert">Backup + Convert</option>';
				}else if($mode == 'convert'){
					echo '<option value="convert" selected="selected">Convert Only</option><option value="backup">Backup Only</option><option value="backup_convert">Backup + Convert</option>';
				}
			?>
	
		</select>
		<br>

		<div style="float:right;clear:both;width: 25%;border: 1px solid gray; padding: 1em;margin:1em">
			<p><strong>Friendfeed Export and Format (v0.6)</strong> &mdash; FFexp.php &amp; FFExp2HTMLex.php - "Paging Edition" (customization of Claudio Cicali's FF backup and archive-to-HTML scripts by Micah Wittman. App wrapper integration by Micah Wittman)</p>
			<br>
			<button id="btn_show_path">Show Path</button><br>
			<br>
			<small>Show Data Directory Location from Last Run (scroll below after clicking):</small>
		</div>
		
		<hr>

		Username: <input id="username" name="username" type="text" value="<?php echo $username; ?>" /><br>
		
		<br>
		<span style="color:gray">Remote Key (optional&mdash;only if private account)</span>: <input id="remote_key" name="remote_key" type="text" value="<?php echo $remote_key; ?>" /><br>
		<hr>
		
		
		<h2>BACKUP</h2>
		
		Backup All Pages: <select name="all_pages" id="all_pages">
			<?php
				if($all_pages || !$hasConfig){
					echo '<option value="Y" selected="selected">Yes</option><option value="N">No</option>';
				}else{
					echo '<option value="N" selected="selected">No</option><option value="Y">Yes</option>';
				}
			?>
			
		</select>
		<br>
		(If not all pages, maximum pages to download): <input style="width: 50px" id="max_pages" name="max_pages" type="text" value="<?php if(!$all_pages) echo $max_pages; ?>" /><br>
		
		<hr>
		
		Include Images
		<select name="download_images" id="download_images">
			<?php
				if($download_images || !$hasConfig){
					echo '<option value="Y" selected="selected">Yes</option><option value="N">No</option>';
				}else{
					echo '<option value="N" selected="selected">No</option><option value="Y">Yes</option>';
				}
			?>
		</select><br>
		
		<hr>
		
		Include Attached Files:
		<select name="download_files" id="download_files">
			<?php
				if($download_files || !$hasConfig){
					echo '<option value="Y" selected="selected">Yes</option><option value="N">No</option>';
				}else{
					echo '<option value="N" selected="selected">No</option><option value="Y">Yes</option>';
				}
			?>
		</select><br><br>
	
		<hr>
	
		<h2>CONVERT</h2>
		
		Posts per HTML output file: <input style="width: 50px" id="convert_limit" name="convert_limit" type="text" value="<?php if($hasConfig){ echo $convert_limit;}else{ echo '200';} ?>" /><br>
		
		Convert All Pages: <select name="convert_all_pages" id="convert_all_pages">
			<?php
				if($convert_all_pages || !$hasConfig){
					echo '<option value="Y" selected="selected">Yes</option><option value="N">No</option>';
				}else{
					echo '<option value="N" selected="selected">No</option><option value="Y">Yes</option>';
				}
			?>
			
		</select>
		
		<br>
		(If not all pages, maximum pages to convert): <input style="width: 50px" id="convert_max_pages" name="convert_max_pages" type="text" value="<?php if(!$convert_all_pages) echo $convert_max_pages; ?>" /><br>
		<br><br>
		
		<hr>
		
		<button style="width:100px; font-weight:bold" id="btn_run">Run</button>
		
	</form>
	
	
	<div style="margin-top:.5em" id="status_display"></div>
	
<script>
function detectIE() {
    var ua = window.navigator.userAgent;

    var msie = ua.indexOf('MSIE ');
    if (msie > 0) {
        // IE 10 or older => return version number
        return parseInt(ua.substring(msie + 5, ua.indexOf('.', msie)), 10);
    }

    var trident = ua.indexOf('Trident/');
    if (trident > 0) {
        // IE 11 => return version number
        var rv = ua.indexOf('rv:');
        return parseInt(ua.substring(rv + 3, ua.indexOf('.', rv)), 10);
    }

    var edge = ua.indexOf('Edge/');
    if (edge > 0) {
       // IE 12 => return version number
       return parseInt(ua.substring(edge + 5, ua.indexOf('.', edge)), 10);
    }

    // other browser
    return false;
}
function formatAMPM(date) { // This is to display 12 hour format like you asked
  var hours = date.getHours();
  var minutes = date.getMinutes();
  var ampm = hours >= 12 ? 'pm' : 'am';
  hours = hours % 12;
  hours = hours ? hours : 12; // the hour '0' should be '12'
  minutes = minutes < 10 ? '0'+minutes : minutes;
  var strTime = hours + ':' + minutes + ' ' + ampm;
  return strTime;
}
function date_stamp(){
	var myDate = new Date();
	return  (myDate.getMonth()+1) + '/' +myDate.getDate()+ '/' +myDate.getFullYear()+ ' ' +formatAMPM(myDate);
}
$(function(){
	if(detectIE()){
		window.location = "http://localhost:8000/windows.php";
	}
	$(document).on("click","#btn_show_path", function(e){
		e.preventDefault();
		$.ajax({
	        type: "GET",
	        url: "http://localhost:8000/message.php?current_done_backup_last&keep",
	        success: function(data){
				$('#status_display').prepend(data + ' <small>(' + date_stamp() + ')</small>' + '<br>');
				console.log(data);
	        }
		});
		$.ajax({
	        type: "GET",
	        url: "http://localhost:8000/message.php?current_done_convert_last&keep",
	        success: function(data){
				$('#status_display').prepend(data + ' <small>(' + date_stamp() + '</small>)' + '<br>');
				console.log(data);
	        }
		});
		return false;
	});

	var init = false;
	var current_page;
	var current_done_backup;
	var current_done_convert;
    $(document).on("click","#btn_run", function(e){
		$('#status_display').prepend('<strong>Running...</strong>' + '<br><hr><br>');
		current_page = '';
		current_done_backup = '';
		current_done_convert = '';
		if(!init){
			init = true;
			var processing_done = false;
			console.log('begin');
			var status_loop = function(){
				//if(processing_done) return;
				setTimeout(function(){
					console.log('settimeout');
					$.ajax({
			            type: "GET",
			            url: "http://localhost:8000/message.php?current_page",
			            success: function(data){
							if(data && data != current_page){

								var smile = (data.indexOf('Done') > -1) ? '<img height="21px" src="smile.jpeg">' : '';
								$('#status_display').prepend(data + smile + ' <small>(' + date_stamp() + '</small>)<br>');
								current_page = data;
							}
							//console.log('current_page-success',data);
			            },
						complete: function(){
							console.log('complete');
							status_loop();
						}
					});
					$.ajax({
			            type: "GET",
			            url: "http://localhost:8000/message.php?current_done_backup",
			            success: function(data){
							if(data && data != current_done_backup){
								var smile = (data.indexOf('Done') > -1) ? '<img height="21px" src="smile.jpeg">' : '';
								$('#status_display').prepend(data + ' <small>(' + date_stamp() + '</small>)' + smile + '<br>');
								current_done_backup = data;
							}
							//console.log('current_done_backup-success',data);
			            }
					});
					$.ajax({
			            type: "GET",
			            url: "http://localhost:8000/message.php?current_done_convert",
			            success: function(data){
							if(data && data != current_done_convert){
								var smile = (data.indexOf('Done') > -1) ? '<img height="21px" src="smile.jpeg">' : '';
								$('#status_display').prepend(data + ' <small>(' + date_stamp() + '</small>)' + smile + '<br>');
								current_done_convert = data;
							}
							console.log('current_done_convert-success',data);
			            }
						
					});

				}, 3000);	
			};
			status_loop(); //init
		}
		console.log('begin-loop');
		e.preventDefault();
        $.ajax({
            type: "POST",
            url: "http://localhost:8000/index.php",
            data: $("#mainform").serialize(),
            success: function(){
				//processing_done = true;
                console.log('success-post');
            }
        });
    });
});
</script>
</body>
</html>
<?php
function execInBackground($cmd) { 
    if (substr(php_uname(), 0, 7) == "Windows"){ 
        pclose(popen("start /B ". $cmd, "r"));  
    } 
    else { 
        exec($cmd . " > /dev/null &");   
    } 
}

if($run_now){
	echo '<br><br>';
	
	/*notify("<script>
		var scroller = setInterval(function() {
          $('body').animate({
              'scrollTop': $(document).height()
          }); 
		}, 500);
          </script>");*/
	
	
	$dirHtml = realpath(dirname(__FILE__));
	$jsonBackupHtml = htmlspecialchars($dirHtml) . DIRECTORY_SEPARATOR . "ff_stream_$username.json";
	$linkyBackup = 'Backup data (json format) located:<br><strong style="font-family:Courier New, fixed">' . $jsonBackupHtml . '</strong>';
	
	$linkyConvert = 'HTML output files are now in directory:<br><br><strong style="font-family:Courier New, fixed"><a href="' . htmlspecialchars("file:///$dirHtml/$username-001.html") . '">' . $dirHtml . '</a></strong>';
	
	if( $mode == 'backup_convert' || $mode == 'backup' ){
		#notify('<br><br> Beginning Backup.');

		#file_put_contents("current_done_backup.dat", ''); //clear
		#file_put_contents("current_done_convert.dat", ''); //clear
		
		#include 'ffexp.php';
		//$command = "php " . realpath(dirname(__FILE__))  . "/ffexp.php";
		$command = PHP_BINARY . " " . realpath(dirname(__FILE__))  . "/ffexp.php";
		
		#exec($command);
		execInBackground($command);

		//notify($linkyBackup);
		//file_put_contents("current_done_backup.dat", $linkyBackup);
		
	} else if( $mode == 'convert' ){ //convert only
		#notify('<br><br>Beginning Conversion to HTML files.');
		#file_put_contents("current_done_backup.dat", ''); //clear
		#file_put_contents("current_done_convert.dat", ''); //clear
		
		#$command = PHP_BINARY . " " . realpath(dirname(__FILE__))  . "/FFExp2HTMLex.php";

		#exec($command);
		#execInBackground($command);
		include 'FFExp2HTMLex.php';
	}
	
	//if backup_convert mode, then convert is initiated at end of backup script
	

	
	#notify('<br><br><img src="smile.jpeg"> All Done.');
}